/**********************************************************************************************
*    Le Nanard vous propose, pas un pais 4 Dés coloré affichés sur un panneaux de 64 pixels   * 
*    en série de 8 x 8 alimentés en 5 volts et commandé par un arduino Nano                   *
***********************************************************************************************/

//declaration des variables et des entrées / sorties
#include <Adafruit_NeoPixel.h>
#define PIN            8
#define NUMPIXELS     64

Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

int pushBut = 2;

int dice0 = 0;
int dice1 = 5;
int dice2 = 40;
int dice3 = 45;

int valDice ;

int nbDice;


//Gestion du Dé n°1
void diceone () {
  valDice = random(1, 7); //Géneration d'un nombre aléatoire de 1 à 6

switch (valDice) { //Attribution d'une couleur et de la position des points sur la matrice ...
  case 1:
    pixels.setPixelColor(9, pixels.Color(0,50,50));
    break;
  case 2:
   pixels.setPixelColor(2, pixels.Color(50,50,0));
   pixels.setPixelColor(16, pixels.Color(50,50,0));
    break;
      case 3:
   pixels.setPixelColor(2, pixels.Color(0,50,0));
   pixels.setPixelColor(16, pixels.Color(0,50,0));
   pixels.setPixelColor(9, pixels.Color(0,50,0));
    break;
      case 4:
   pixels.setPixelColor(2, pixels.Color(0,0,50));
   pixels.setPixelColor(0, pixels.Color(0,0,50));
   pixels.setPixelColor(18, pixels.Color(0,0,50));
   pixels.setPixelColor(16, pixels.Color(0,0,50));
    break;
      case 5:
   pixels.setPixelColor(9, pixels.Color(50,0,0));
   pixels.setPixelColor(2, pixels.Color(50,0,0));
   pixels.setPixelColor(0, pixels.Color(50,0,0));
   pixels.setPixelColor(18, pixels.Color(50,0,0));
   pixels.setPixelColor(16, pixels.Color(50,0,0));
    break;
      case 6:
   pixels.setPixelColor(1, pixels.Color(50,50,50));
   pixels.setPixelColor(17, pixels.Color(50,50,50));
   pixels.setPixelColor(2, pixels.Color(50,50,50));
   pixels.setPixelColor(0, pixels.Color(50,50,50));
   pixels.setPixelColor(18, pixels.Color(50,50,50));
   pixels.setPixelColor(16, pixels.Color(50,50,50));
    break;
  }
}


//Gestion du Dé n°2
void dicetwo () {
  valDice = random(1, 7);

switch (valDice) {
  case 1:
    pixels.setPixelColor((9 + dice1), pixels.Color(0,50,50));
    break;
  case 2:
   pixels.setPixelColor((2 + dice1), pixels.Color(50,50,0));
   pixels.setPixelColor((16 + dice1), pixels.Color(50,50,0));
    break;
      case 3:
   pixels.setPixelColor((2 + dice1), pixels.Color(0,50,0));
   pixels.setPixelColor((16 + dice1), pixels.Color(0,50,0));
   pixels.setPixelColor((9 + dice1), pixels.Color(0,50,0));
    break;
      case 4:
   pixels.setPixelColor((2 + dice1), pixels.Color(0,0,50));
   pixels.setPixelColor((0 + dice1), pixels.Color(0,0,50));
   pixels.setPixelColor((18 + dice1), pixels.Color(0,0,50));
   pixels.setPixelColor((16 + dice1), pixels.Color(0,0,50));
    break;
      case 5:
   pixels.setPixelColor((9 + dice1), pixels.Color(50,0,0));
   pixels.setPixelColor((2 + dice1), pixels.Color(50,0,0));
   pixels.setPixelColor((0 + dice1), pixels.Color(50,0,0));
   pixels.setPixelColor((18 + dice1), pixels.Color(50,0,0));
   pixels.setPixelColor((16 + dice1), pixels.Color(50,0,0));
    break;
      case 6:
   pixels.setPixelColor((1 + dice1), pixels.Color(50,50,50));
   pixels.setPixelColor((17 + dice1), pixels.Color(50,50,50));
   pixels.setPixelColor((2 + dice1), pixels.Color(50,50,50));
   pixels.setPixelColor((0 + dice1), pixels.Color(50,50,50));
   pixels.setPixelColor((18 + dice1), pixels.Color(50,50,50));
   pixels.setPixelColor((16 + dice1), pixels.Color(50,50,50));
    break;

  }
}


//Gestion du Dé n°3
void dicetre () {
  valDice = random(1, 7);

switch (valDice) {
  case 1:
    pixels.setPixelColor((9 + dice2), pixels.Color(0,50,50));
    break;
  case 2:
   pixels.setPixelColor((2 + dice2), pixels.Color(50,50,0));
   pixels.setPixelColor((16 + dice2), pixels.Color(50,50,0));
    break;
      case 3:
   pixels.setPixelColor((2 + dice2), pixels.Color(0,50,0));
   pixels.setPixelColor((16 + dice2), pixels.Color(0,50,0));
   pixels.setPixelColor((9 + dice2), pixels.Color(0,50,0));
    break;
      case 4:
   pixels.setPixelColor((2 + dice2), pixels.Color(0,0,50));
   pixels.setPixelColor((0 + dice2), pixels.Color(0,0,50));
   pixels.setPixelColor((18 + dice2), pixels.Color(0,0,50));
   pixels.setPixelColor((16 + dice2), pixels.Color(0,0,50));
    break;
      case 5:
   pixels.setPixelColor((9 + dice2), pixels.Color(50,0,0));
   pixels.setPixelColor((2 + dice2), pixels.Color(50,0,0));
   pixels.setPixelColor((0 + dice2), pixels.Color(50,0,0));
   pixels.setPixelColor((18 + dice2), pixels.Color(50,0,0));
   pixels.setPixelColor((16 + dice2), pixels.Color(50,0,0));
    break;
      case 6:
   pixels.setPixelColor((1 + dice2), pixels.Color(50,50,50));
   pixels.setPixelColor((17 + dice2), pixels.Color(50,50,50));
   pixels.setPixelColor((2 + dice2), pixels.Color(50,50,50));
   pixels.setPixelColor((0 + dice2), pixels.Color(50,50,50));
   pixels.setPixelColor((18 + dice2), pixels.Color(50,50,50));
   pixels.setPixelColor((16 + dice2), pixels.Color(50,50,50));
    break;

  }
}


//Gestion du Dé n°4
void dicefor () {
  valDice = random(1, 7);

switch (valDice) {
  case 1:
    pixels.setPixelColor((9 + dice3), pixels.Color(0,50,50));
    break;
  case 2:
   pixels.setPixelColor((2 + dice3), pixels.Color(50,50,0));
   pixels.setPixelColor((16 + dice3), pixels.Color(50,50,0));
    break;
      case 3:
   pixels.setPixelColor((2 + dice3), pixels.Color(0,50,0));
   pixels.setPixelColor((16 + dice3), pixels.Color(0,50,0));
   pixels.setPixelColor((9 + dice3), pixels.Color(0,50,0));
    break;
      case 4:
   pixels.setPixelColor((2 + dice3), pixels.Color(0,0,50));
   pixels.setPixelColor((0 + dice3), pixels.Color(0,0,50));
   pixels.setPixelColor((18 + dice3), pixels.Color(0,0,50));
   pixels.setPixelColor((16 + dice3), pixels.Color(0,0,50));
    break;
      case 5:
   pixels.setPixelColor((9 + dice3), pixels.Color(50,0,0));
   pixels.setPixelColor((2 + dice3), pixels.Color(50,0,0));
   pixels.setPixelColor((0 + dice3), pixels.Color(50,0,0));
   pixels.setPixelColor((18 + dice3), pixels.Color(50,0,0));
   pixels.setPixelColor((16 + dice3), pixels.Color(50,0,0));
    break;
      case 6:
   pixels.setPixelColor((1 + dice3), pixels.Color(50,50,50));
   pixels.setPixelColor((17 + dice3), pixels.Color(50,50,50));
   pixels.setPixelColor((2 + dice3), pixels.Color(50,50,50));
   pixels.setPixelColor((0 + dice3), pixels.Color(50,50,50));
   pixels.setPixelColor((18 + dice3), pixels.Color(50,50,50));
   pixels.setPixelColor((16 + dice3), pixels.Color(50,50,50));
    break;

  }
}

//Roullement des dés
void rollDice() {
    for(int i=1;i<25;i++){
    diceone ();
    //et allumage si déclaré
        if(nbDice > 1){
          dicetwo ();
    }
        if(nbDice > 2){
          dicetre ();;
    }
        if(nbDice > 3){
          dicefor ();
    }

   pixels.show();
    
delay((i*30));
pixels.clear();
   }
}

void setup() {

  pinMode(pushBut, INPUT);
  pixels.begin(); // This initializes the NeoPixel library.
  pixels.setPixelColor(27, pixels.Color(50,0,50));
  pixels.show();
  delay(2500);

//Sélection du nombre de Dés souhaité
 for(int i=0;i<5;i++){
   if ((digitalRead(pushBut)) and (i=1)) {
    pixels.setPixelColor(28, pixels.Color(50,0,50));
    pixels.show();
    nbDice = 2;
    delay(1500);
   }
      if ((digitalRead(pushBut)) and (i=1)) {
    pixels.setPixelColor(35, pixels.Color(50,0,50));
    pixels.show();
    nbDice = 3;
    delay(1500);
   }
      if ((digitalRead(pushBut)) and (i=1)) {
    pixels.setPixelColor(36, pixels.Color(50,0,50));
    pixels.show();
    nbDice = 4;
    delay(1500);
   } 
  
 }
}

void loop() {  //Lancement des Dés

   if (digitalRead(pushBut)) {
    rollDice();
   }
 
}
